#ifndef HIT_H
#define HIT_H

#include <QGLViewer/frame.h>
#include "material.h"
#include <GL/glut.h>

class Hit
{
public :
  Hit() { setTime(1.0E5); normalChanged=true; }

  qglviewer::Vec intersection() const { return intersection_; }
  qglviewer::Vec normal() const;
  float time() const { return time_; }
  const Material& material() const { return material_; }

  void setIntersection(const qglviewer::Vec& intersection) { intersection_ = intersection; }
  void setNormal(const qglviewer::Vec& n);
  void setMaterial(const Material& material) { material_ = material; }
  void setTime(float time) { time_ = time; }
  
  void setUV(float u, float v){
	  u_=u; v_=v;
  }

  float u() const{return u_;}
  float v() const{return v_;}

  // "Extension: Perturbation de normales"
  //qglviewer::Vec bumpMapNormal() const { return bumpMapNormal_; }
  //void setbumpMapNormal(const qglviewer::Vec& n) { bumpMapNormal_ = n; }
  int coeffSpecularMap() const { return coeffSpecularMap_;}
  void setCoeffSpecularMap(const int c) { coeffSpecularMap_ = c; }

  void draw() const;


  void setTangentSpace(const qglviewer::Vec &t, const qglviewer::Vec &bt){
	  tangent_[0]=t;
	  tangent_[1]=bt;
  }

  bool directColor;
  Color color_;
private:
  qglviewer::Vec intersection_;
  mutable qglviewer::Vec normal_;
  qglviewer::Vec tangent_[2];

  mutable bool normalChanged;

  Material material_;
  float time_;

  // Texture coordinates
  float u_;
  float v_;

  // "Extension: Perturbation de normales"
  qglviewer::Vec bumpMapNormal_;
  int coeffSpecularMap_;

  
};

#endif // HIT_H
